778. Swim in Rising Water

复制代码
package LeetCode_778

import java.util.*

/**
 * 778. Swim in Rising Water
 * https://leetcode.com/problems/swim-in-rising-water/
 * On an N x N grid, each square grid[i][j] represents the elevation at that point (i,j).
Now rain starts to fall. At time t, the depth of the water everywhere is t.
You can swim from a square to another 4-directionally adjacent square if and only if the elevation of both squares individually are at most t.
You can swim infinite distance in zero time. Of course, you must stay within the boundaries of the grid during your swim.
You start at the top left square (0, 0). What is the least time until you can reach the bottom right square (N-1, N-1)?

Example 1:
Input: [[0,2],[1,3]]
Output: 3
Explanation:
At time 0, you are in grid location (0, 0).
You cannot go anywhere else because 4-directionally adjacent neighbors have a higher elevation than t = 0.
You cannot reach point (1, 1) until time 3.
When the depth of water is 3, we can swim anywhere inside the grid.

Example 2:
Input: [[0,1,2,3,4],[24,23,22,21,5],[12,13,14,15,16],[11,17,18,19,20],[10,9,8,7,6]]
Output: 16
Explanation:
0  1  2  3  4
24 23 22 21  5
12 13 14 15 16
11 17 18 19 20
10  9  8  7  6
The final route is marked in bold.
We need to wait until time 16 so that (0, 0) and (4, 4) are connected.

Note:
1. 2 <= N <= 50.
2. grid[i][j] is a permutation of [0, ..., N*N - 1].
 * */
class Solution {
    /*
    * solution: BFS + Binary Search,
    * binary search to find the minimum walkable rain level, for each level use bfs to check if a path,
    * Time:O(log(n^2)*n^2), Space:O(n^2), because number of node is n^2
    * */
    fun swimInWater(grid: Array<IntArray>): Int {
        if (grid == null || grid.isEmpty()) {
            return 0
        }
        val n = grid.size
        var left = grid[0][0]
        var right = n * n - 1
        while (left < right) {
            val mid = left + (right - left) / 2
            if (hasPath(grid, mid)) {
                right = mid
            } else {
                left = mid + 1
            }
        }
        return left
    }

    private fun hasPath(grid: Array<IntArray>, waterHeight: Int): Boolean {
        val queue = LinkedList<Pair<Int, Int>>()
        val n = grid.size
        val visited = BooleanArray(n * n)
        val directions = intArrayOf(0, 1, 0, -1, 0)
        queue.offer(Pair(0, 0))
        //set the index to visited
        visited[0 * n + 0] = true
        while (queue.isNotEmpty()) {
            val cur = queue.pop()
            if (cur.first == n - 1 && cur.second == n - 1) {
                return true
            }
            for (d in 0 until 4) {
                val newX = cur.first + directions[d]
                val newY = cur.second + directions[d + 1]
                if (newX < 0 || newY < 0 || newX >= n || newY >= n || grid[newX][newY] > waterHeight) {
                    continue
                }
                if (visited[newX * n + newY]) {
                    continue
                }
                //set the index to visited
                visited[newX * n + newY] = true
                queue.offer(Pair(newX, newY))
            }
        }
        return false
    }
}
复制代码

 

posted @   johnny_zhao  阅读(83)  评论(0编辑  收藏  举报
编辑推荐:
· AI与.NET技术实操系列(二):开始使用ML.NET
· 记一次.NET内存居高不下排查解决与启示
· 探究高空视频全景AR技术的实现原理
· 理解Rust引用及其生命周期标识(上)
· 浏览器原生「磁吸」效果!Anchor Positioning 锚点定位神器解析
阅读排行:
· DeepSeek 开源周回顾「GitHub 热点速览」
· 物流快递公司核心技术能力-地址解析分单基础技术分享
· .NET 10首个预览版发布:重大改进与新特性概览!
· AI与.NET技术实操系列(二):开始使用ML.NET
· .NET10 - 预览版1新功能体验(一)
点击右上角即可分享
微信分享提示